/**********************************************************************\

File:		program globals.h

Purpose:	This is the header file for all the program-specific
			global variables, #defines, enums, and structs.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#ifndef _PROGRAM_GLOBALS_H_
#define _PROGRAM_GLOBALS_H_

#define CREATOR			'Lym!'
#define APPLICATION_NAME "\pLose Your Marbles!"
#define	SAVE_TYPE		'Sqrs'
#define	SAVE_VERSION	1

enum					/* window indices in gTheWindowData[] lists */
{
	kAbout=0,			/* about box */
	kAboutMSG,			/* "About MSG" splash screen */
	kHelp,				/* help window */
	kMainWindow			/* main graphics window */
};

#define	NUM_WINDOWS		4		/* total number of windows (see above enum) */

enum ErrorTypes
{
	allsWell=0,
	
	/* shell errors */
	kNoMemory,
	kNoMemoryAndQuitting,
	kProgramIntegrityNotVerified,
	kProgramIntegritySet,
	kSystemTooOld,
	userCancelErr,
	
	/* deBinHex errors */
	kCantOpenInputFile,
	kCantCreateTempFile,
	kBinHexErr,
	kDiskReadErr,
	kDiskWriteErr,
	kNeedMoreBinHexErr,

	/* program-specific errors */
	kCantCreateGame,
	kCantOpenGameToSave,
	kDiskFull,
	kCantWriteGame,
	kCantOpenGameToLoad,
	kCantLoadGame,
	kBadChecksum,
	kSaveVersionNotSupported
};

#define MAX_ROWS		8
#define	MAX_COLS		MAX_ROWS

extern	CIconHandle		gTheCIcon[10];
extern	Handle			gTheIcon[10];
extern	short			Board[MAX_ROWS][MAX_COLS];
extern	short			gNumRows, gNumColumns;
extern	short			gCurrentRow, gCurrentColumn;
extern	Point			gMoves[MAX_ROWS*MAX_COLS];
extern	short			gNumMoves;
extern	FSSpec			gameFile;
extern	Boolean			deleteTheThing;

#endif
